/* ============================= C MeatAxe ==================================
   File:        $Id: zcmprow.c,v 1.1.1.1 2000/01/07 16:42:27 mringe Exp $
   Comment:     Compare rows.
   --------------------------------------------------------------------------
   (C) Copyright 1998 Michael Ringe, Lehrstuhl D fuer Mathematik,
   RWTH Aachen, Germany  <mringe@math.rwth-aachen.de>
   This program is free software; see the file COPYING for details.
   ========================================================================== */


#include "meataxe.h"
#include <string.h>
#include <stdlib.h>



/*{{{ --------------------------------------------------------------------------
!section kernel.ff.row
!function FfCmpRows "Compare two rows"
!synopsis 
    int FfCmpRows(PTR dest, PTR src);
!arg p1
    Pointer to the first matrix.
!arg p2
    Pointer to the second matrix.
!return
    The function returns 0 if the two rows are identical. Otherwise the
    return value is different from 0.
!description
    This function compares two rows. As with all row operations, the row 
    length must have been set before with |FfSetNoc()|. 
    The return value is negative if the first row is `less' than the second 
    row, and it is positive if the first row is `greater' than the second 
    row. However, the ordering defined by |FfCmpRows()| depends on the internal
    representation of finite field elements and can differ between dirrerent
    kernels or between different hardware architectures.
-------------------------------------------------------------------------- }}}*/

int FfCmpRows(PTR p1, PTR p2)

{	
    return memcmp(p1,p2,FfTrueRowSize(FfNoc));
}

